package de.ivu.elect.business.system.control.status;

import java.io.File;
import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.exchange.control.ImportExportKonfiguration;
import de.ivu.elect.business.mandant.entity.Mandant;
import de.ivu.elect.business.system.control.SystemRequirements;
import de.ivu.elect.business.system.entity.SystemStatusOptionGroup;
import de.ivu.elect.jee.presentation.status.StatusEntry;
import de.ivu.elect.jee.presentation.status.StatusOptionType;

/**
 *  on 26.05.2017.
 */
public class SystemFreeDiskSpaceSystemStatusOptionResolver extends AbstractSystemStatusOptionResolver {

  private static final StatusOptionType DISK_SPACE = new StatusOptionType() {
  };

  @Inject
  private transient SystemRequirements systemRequirements;

  @Inject
  private transient ImportExportKonfiguration importExportKonfiguration;

  @Override
  protected StatusEntry resolveSystemStatusOption(SystemStatusOption systemStatusOption) {

    long erwartet = systemRequirements.getFreeDiskSpaceInBytes();
    long vorhanden = new File(importExportKonfiguration.getServerVerzeichnis()).getFreeSpace();
    if (vorhanden >= erwartet) {
      return ok("system.info.konfiguriert.disk.space.ok", vorhanden);
    }
    return error("system.info.konfiguriert.disk.space.nok", vorhanden, erwartet);
  }

  @Override
  protected boolean isAccept(Mandant mandant) {
    return mandant.getArt().isSystemMandant();
  }

  @Override
  protected List<SystemStatusOption> getStatusOptionsInternal(Mandant mandant) {
    return Collections.singletonList(new SystemStatusOption(DISK_SPACE, mandant));
  }

  @Override
  public SystemStatusOptionGroup getSystemStatusOptionGroup() {
    return SystemStatusOptionGroup.SYSTEM;
  }



}
